import request from '@/utils/request';
import type { ApiResult, PageResult } from '@/api';
import type { BszxEra, BszxEraParam } from './model';

/**
 * 分页查询百色中学-年代
 */
export async function pageBszxEra(params: BszxEraParam) {
  const res = await request.get<ApiResult<PageResult<BszxEra>>>(
    '/bszx/bszx-era/page',
    {
      params
    }
  );
  if (res.code === 0) {
    return res.data;
  }
  return Promise.reject(new Error(res.message));
}

/**
 * 查询百色中学-年代列表
 */
export async function listBszxEra(params?: BszxEraParam) {
  const res = await request.get<ApiResult<BszxEra[]>>(
    '/bszx/bszx-era',
    {
      params
    }
  );
  if (res.code === 0 && res.data) {
    return res.data;
  }
  return Promise.reject(new Error(res.message));
}

/**
 * 添加百色中学-年代
 */
export async function addBszxEra(data: BszxEra) {
  const res = await request.post<ApiResult<unknown>>(
    '/bszx/bszx-era',
    data
  );
  if (res.code === 0) {
    return res.message;
  }
  return Promise.reject(new Error(res.message));
}

/**
 * 修改百色中学-年代
 */
export async function updateBszxEra(data: BszxEra) {
  const res = await request.put<ApiResult<unknown>>(
    '/bszx/bszx-era',
    data
  );
  if (res.code === 0) {
    return res.message;
  }
  return Promise.reject(new Error(res.message));
}

/**
 * 删除百色中学-年代
 */
export async function removeBszxEra(id?: number) {
  const res = await request.del<ApiResult<unknown>>(
    '/bszx/bszx-era/' + id
  );
  if (res.code === 0) {
    return res.message;
  }
  return Promise.reject(new Error(res.message));
}

/**
 * 批量删除百色中学-年代
 */
export async function removeBatchBszxEra(data: (number | undefined)[]) {
  const res = await request.del<ApiResult<unknown>>(
    '/bszx/bszx-era/batch',
    {
      data
    }
  );
  if (res.code === 0) {
    return res.message;
  }
  return Promise.reject(new Error(res.message));
}

/**
 * 根据id查询百色中学-年代
 */
export async function getBszxEra(id: number) {
  const res = await request.get<ApiResult<BszxEra>>(
    '/bszx/bszx-era/' + id
  );
  if (res.code === 0 && res.data) {
    return res.data;
  }
  return Promise.reject(new Error(res.message));
}
